/* Include files */

#include "hive_sfun.h"
#include "c1_hive.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "hive_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_hiveInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_hive(void);
static void initialize_params_c1_hive(void);
static void enable_c1_hive(void);
static void disable_c1_hive(void);
static void update_debugger_state_c1_hive(void);
static const mxArray *get_sim_state_c1_hive(void);
static void set_sim_state_c1_hive(const mxArray *c1_st);
static void finalize_c1_hive(void);
static void sf_c1_hive(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u);
static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_active_c1_hive = 0U;
}

static void initialize_params_c1_hive(void)
{
}

static void enable_c1_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c1_hive(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void update_debugger_state_c1_hive(void)
{
}

static const mxArray *get_sim_state_c1_hive(void)
{
  return NULL;
}

static void set_sim_state_c1_hive(const mxArray *c1_st)
{
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_hive(void)
{
}

static void sf_c1_hive(void)
{
  int32_T c1_i0;
  uint8_T c1_previousEvent;
  int32_T c1_i1;
  real_T c1_in[1250];
  real_T c1_fc1;
  real_T c1_fc2;
  real_T c1_nargout = 1.0;
  real_T c1_nargin = 3.0;
  real_T c1_Power;
  int32_T c1_i2;
  real_T c1_u[1250];
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  real_T c1_c_u;
  const mxArray *c1_c_y = NULL;
  const mxArray *c1_BandPower;
  real_T c1_d0;
  real_T *c1_b_fc1;
  real_T *c1_b_fc2;
  real_T *c1_b_Power;
  real_T (*c1_b_in)[1250];
  c1_b_Power = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_b_fc2 = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_b_fc1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_b_in = (real_T (*)[1250])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  for (c1_i0 = 0; c1_i0 < 1250; c1_i0 = c1_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c1_b_in)[c1_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c1_b_fc1, 1U);
  _SFD_DATA_RANGE_CHECK(*c1_b_fc2, 2U);
  _SFD_DATA_RANGE_CHECK(*c1_b_Power, 3U);
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for (c1_i1 = 0; c1_i1 < 1250; c1_i1 = c1_i1 + 1) {
    c1_in[c1_i1] = (*c1_b_in)[c1_i1];
  }

  c1_fc1 = *c1_b_fc1;
  c1_fc2 = *c1_b_fc2;
  sf_debug_symbol_scope_push(6U, 0U);
  sf_debug_symbol_scope_add("nargout", &c1_nargout, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c1_nargin, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("Power", &c1_Power, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("fc2", &c1_fc2, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("fc1", &c1_fc1, c1_b_sf_marshall);
  sf_debug_symbol_scope_add("in", &c1_in, c1_sf_marshall);
  CV_EML_FCN(0, 0);

  /*  This block supports the Embedded MATLAB subset. */
  /*  See the help menu for details.  */
  /* eml.extrinsic('ParseActiViewData'); */
  /* eml.extrinsic('ParseDataTrigguer'); */
  /* eml.extrinsic('tic'); */
  _SFD_EML_CALL(0,7);
  _SFD_EML_CALL(0,9);
  c1_Power = 0.0;
  _SFD_EML_CALL(0,11);
  for (c1_i2 = 0; c1_i2 < 1250; c1_i2 = c1_i2 + 1) {
    c1_u[c1_i2] = c1_in[c1_i2];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 1U, 0U, 1, 1250));
  c1_b_u = c1_fc1;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  c1_c_u = c1_fc2;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_c_u, 0, 0U, 0U, 0U, 0));
  c1_BandPower = sf_mex_call("BandPower", 1U, 3U, 14, c1_y, 14, c1_b_y, 14,
    c1_c_y);
  sf_mex_import("BandPower", sf_mex_dup(c1_BandPower), &c1_d0, 1, 0, 0U, 0, 0U,
                0);
  c1_Power = c1_d0;
  sf_mex_destroy(&c1_BandPower);
  _SFD_EML_CALL(0,-11);
  sf_debug_symbol_scope_pop();
  *c1_b_Power = c1_Power;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_hiveMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  int32_T c1_i3;
  real_T c1_b_u[1250];
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  for (c1_i3 = 0; c1_i3 < 1250; c1_i3 = c1_i3 + 1) {
    c1_b_u[c1_i3] = (*((real_T (*)[1250])c1_u))[c1_i3];
  }

  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 1U, 0U, 1, 1250));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

static const mxArray *c1_b_sf_marshall(void *c1_chartInstance, void *c1_u)
{
  const mxArray *c1_y = NULL;
  real_T c1_b_u;
  const mxArray *c1_b_y = NULL;
  c1_y = NULL;
  c1_b_u = *((real_T *)c1_u);
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c1_y, c1_b_y);
  return c1_y;
}

const mxArray *sf_c1_hive_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  sf_mex_assign(&c1_nameCaptureInfo, sf_mex_create("nameCaptureInfo", NULL, 0,
    0U, 1U, 0U, 2, 0, 1));
  return c1_nameCaptureInfo;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_hive_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3375874931U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3318451780U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2997761612U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3412626347U);
}

mxArray *sf_c1_hive_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3344846344U);
    pr[1] = (double)(2891786136U);
    pr[2] = (double)(2698068126U);
    pr[3] = (double)(1110079332U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1250);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if (!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_hiveMachineNumber_,
          1,
          1,
          1,
          4,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance.chartNumber),
          &(chartInstance.instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_hiveMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_hiveMachineNumber_,
            chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_hiveMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[2];
            dimVector[0]= 1250;
            dimVector[1]= 1;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"in",0,c1_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"fc1",0,
                              c1_b_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"fc2",0,
                              NULL);
          _SFD_SET_DATA_PROPS(3,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"Power",0,
                              NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,292);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c1_in)[1250];
          real_T *c1_fc1;
          real_T *c1_fc2;
          real_T *c1_Power;
          c1_Power = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c1_fc2 = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          c1_fc1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          c1_in = (real_T (*)[1250])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_in);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_fc1);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_fc2);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_Power);
        }
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_hiveMachineNumber_,
      chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c1_hive(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c1_hive();
  initialize_c1_hive();
}

static void sf_opaque_enable_c1_hive(void *chartInstanceVar)
{
  enable_c1_hive();
}

static void sf_opaque_disable_c1_hive(void *chartInstanceVar)
{
  disable_c1_hive();
}

static void sf_opaque_gateway_c1_hive(void *chartInstanceVar)
{
  sf_c1_hive();
}

static mxArray* sf_opaque_get_sim_state_c1_hive(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c1_hive();
  return st;
}

static void sf_opaque_set_sim_state_c1_hive(void *chartInstanceVar, const
  mxArray *st)
{
  set_sim_state_c1_hive(sf_mex_dup(st));
}

static void sf_opaque_terminate_c1_hive(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c1_hive();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_hive(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_hive();
  }
}

static void mdlSetWorkWidths_c1_hive(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("hive","hive",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("hive","hive",1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("hive","hive",1,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"hive","hive",1,3);
      sf_mark_chart_reusable_outputs(S,"hive","hive",1,1);
    }

    sf_set_rtw_dwork_info(S,"hive","hive",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3664413039U));
  ssSetChecksum1(S,(32122877U));
  ssSetChecksum2(S,(1093307617U));
  ssSetChecksum3(S,(973561224U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_hive(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "hive", "hive",1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_hive(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_hive;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c1_hive;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_hive;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_hive;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_hive;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c1_hive;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c1_hive;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_hive;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_hive;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_hive;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c1_hive_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_hive(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_hive(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_hive(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_hive_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
